<template>
  <q-layout :view="viewDisplay">
    <q-layout-header>
      <q-toolbar inverted>
        <div class="col-3">
          <q-btn
              flat
              dense
              round
              @click="menu"
              v-if="!leftDrawerOpen"
              aria-label="Menu"
          >
            <q-icon name="menu" v-show="!leftDrawerOpen" />
          </q-btn>
        </div>
        <div class="col-6">
          <q-toolbar-title>
          </q-toolbar-title>
        </div>
        <div class="col-3 flex justify-end">
          <q-select
            :stack-label="$t('Language')"
            v-model="languages"
            @input="setLanguage"
            :options="available_languages"
          />
        </div>
      </q-toolbar>
    </q-layout-header>

    <q-layout-drawer
      :width="220"
      v-model="leftDrawerOpen"
      :mini="miniState"
      :mini-width="60"
      :content-class="drawerCls"

  >
      <q-list
        no-border
        link
        inset-delimiter
      >
        <q-list-header class="menu-header col" v-if="!miniState" >
          <q-btn flat dense round @click="menu" aria-label="Menu"
                  style="position: relative; top: -10px; left: -10px; color: white;">
            <q-icon name="sort" v-show="leftDrawerOpen && !miniState" class="text-primary"/>
            <q-icon name="menu" v-show="!leftDrawerOpen || miniState" />
          </q-btn>
          <div class="row justify-center">
            <div class="menu-user-name text-primary">
              <div><strong>{{user}}</strong></div>
              <div class="admin text-primary" v-if="user && user.admin">Admin</div>
            </div>
          </div>
          <div v-if="isAdmin" class="row justify-center">
            <div  class="menu-user-image" style="box-shadow: rgba(14, 30, 37, 0.12) 0px 2px 4px 0px, rgba(14, 30, 37, 0.32) 0px 2px 16px 0px;">
                <div class="content">
                  <img :src="imageUrl" clickable  alt="default admin logo" :title="$t('Upload_logo')" class="image">
                  <div class="button">
                    <q-btn
                            :title="$t('Upload_logo')"
                            class="spacing"
                            size="sm"
                            round
                            color="orange"
                            icon="image"
                            @click.native="displayThumbnailInDialog()"
                          />
                  </div>
                </div>
            </div>
          </div>
          <div v-else class="row justify-center">
             <div  class="menu-user-image" style="box-shadow: rgba(14, 30, 37, 0.12) 0px 2px 4px 0px, rgba(14, 30, 37, 0.32) 0px 2px 16px 0px;">
              <img :src="imageUrl">
            </div>
          </div>
        </q-list-header>
        <hr style="width: 80%">
        <q-item @click.native="menu" v-show="!leftDrawerOpen || miniState">
          <q-item-side icon="menu" />
        </q-item>
        <q-item @click.native="searchModalOpened = true">
          <q-item-side icon="search" />
          <q-item-main :label="$t('Search')"/>
        </q-item>
        <q-item to="/home">
          <q-item-side icon="home" />
          <q-item-main :label="$t('Home')"/>
        </q-item>
        <q-item to="/applications" v-if="isAdmin">
          <q-item-side icon="get_app" />
          <q-item-main :label="$t('Catalog')"/>
        </q-item>
        <q-item to="/installed" v-if="isAdmin">
          <q-item-side icon="apps" />
          <q-item-main :label="$t('Applications')"/>
        </q-item>
        <q-item to="/users" v-if="isAdmin">
          <q-item-side icon="people" />
          <q-item-main :label="$t('Users')"/>
        </q-item>
        <q-item to="/categories" v-if="isAdmin">
          <q-item-side icon="class" />
          <q-item-main :label="$t('Categories')"/>
        </q-item>
        <q-item to="/playlists" v-if="user">
          <q-item-side icon="playlist_play" />
          <q-item-main :label="$t('Playlists')"/>
        </q-item>
        <q-item to="/process" v-if="isAdmin">
          <q-item-side icon="build" />
          <q-item-main label="Project reference"/>
        </q-item>
        <q-item > <!-- empty item for scroll -->
        </q-item>
      </q-list>

    </q-layout-drawer>
    <q-page-sticky position="bottom-left" :style="loginBtnStyle" class="login-sticky">
        <q-list :class="loginListClass" no-border
          link
          inset-delimiter>
          <q-item class="login" v-if="user" @click.native="logoff()">
            <q-item-side icon="exit_to_app" />
            <q-item-main :label="$t('Logoff')"/>
          </q-item>
          <q-item class="login" @click.native="login()" v-else>
            <q-item-side icon="account_box" />
            <q-item-main :label="$t('Login')"/>
          </q-item>
        </q-list>
    </q-page-sticky>
    <q-page-container>
      <router-view />
    </q-page-container>
    <search-modal v-model="searchModalOpened" :searched="searchModel"/>
    <q-dialog v-model="uploadProfileImageDialoddiplayed" :ok=false >
      <span slot="title" class="row items-center">
        <div class="text-h6">{{ $t('Upload Profile image') }}</div>
        <q-btn icon="close" flat round dense size="sm" @click.native="closeUpload()"/>
      </span>
      <div slot="body" >
        <q-uploader :url="categoryThumbnailUrl" send-raw method="PUT"
        :upload-factory="uploadFile" max-file-size="500000" @uploaded="finishedUpload" @fail="uploadFailed"
        auto-expand/>
      </div>
    </q-dialog>
  </q-layout>
</template>

<script>
import { openURL } from 'quasar'
import {mapState, mapActions} from 'vuex'
import SearchModal from '../components/search-modal'

export default {
  name: 'LayoutDefault',
  data () {
    return {
      isDesktop: this.$q.platform.is.desktop,
      leftDrawerOpen: true,
      searchModel: '',
      searchModalOpened: false,
      displaySearchBar: true,
      viewDisplay: 'lhr LpR lFf',
      miniState: window.innerWidth < 1024, // lower than large equivalent
      languages: 'en-us',
      uploadProfileImageDialoddiplayed: false,
      available_languages: [
        {
          'label': 'Français',
          'value': 'fr'
        },
        {
          'label': 'English',
          'value': 'en-us'
        },
        {
          'label': 'عربية',
          'value': 'ar'
        },
        {
          'label': 'ভাষা',
          'value': 'bn'
        },
        {
          'label': 'ဘာသာစကား',
          'value': 'my'
        },
        {
          'label': 'vasa',
          'value': 'rhg'
        },
        {
          'label': 'spanish',
          'value': 'es'
        },
        {
          'label': 'Lugha',
          'value': 'sw'
        },
        {
          'label': 'ቋንቋ',
          'value': 'am'
        },
        {
          'label': 'Γλώσσα',
          'value': 'el'
        },
        {
          'label': 'زبان',
          'value': 'fa-ir'
        },
        {
          'label': 'भाषा',
          'value': 'hi'
        },
        {
          'label': 'ژبه',
          'value': 'ps'
        },
        {
          'label': 'Ururimi',
          'value': 'run'
        },
        {
          'label': ' زبان',
          'value': 'ur'
        },
        {
          'label': 'Українська мова',
          'value': 'uk'
        },
        {
          'label': 'Română',
          'value': 'ro'
        },
        {
          'label': 'Pусский язык',
          'value': 'ru'
        }
      ]
    }
  },
  computed: {
    ...mapState({
      user: (state) => {
        if (state.oidc && state.oidc.user) {
          return state.oidc.user.name
        }
        return null
      },
      isAdmin: (state) => {
        if (state.oidc && state.oidc.user && state.oidc.user.roles) {
          return (state.oidc.user.roles === 'admin' || state.oidc.user.roles.includes('admin'))
        }
        return false
      }
    }),
    loginBtnStyle: function () {
      let style = this.miniState ? 'width: 60px;' : 'width: 220px;'
      return style + (this.leftDrawerOpen ? 'transform: translateX(0px);' : 'transform: translateX(-220px);')
    },
    loginListClass: function () {
      return this.miniState ? 'login-list login-list-mini' : 'login-list'
    },
    drawerCls: function () {
      return this.miniState ? 'menu login-list-mini' : 'menu'
    },
    imageUrl: function () {
      return this.logos + '?' + this.pictureSuffix
    },
    ...mapState('home',
      {
        logos: (state) => state.logos,
        pictureSuffix: (state) => state.pictureSuffix
      })
  },
  methods: {
    ...mapActions('home', ['getAdminLogo', 'setAdminLogo']),
    ...mapActions([
      'authenticateOidc',
      'signOutOidc'
    ]),
    openURL,
    displayThumbnailInDialog: function () {
      this.uploadProfileImageDialoddiplayed = true
    },
    finishedUpload: function () {
      this.closeUpload()
    },
    uploadFailed: function () {
      this.$q.notify('Upload failed. Is file too big ?')
    },
    closeUpload: function () {
      this.uploadProfileImageDialoddiplayed = false
      this.getAdminLogo()
    },
    uploadFile: function (file, updateProgress) {
      let promise = this.setAdminLogo({file: file, progress: updateProgress})
      return promise
    },
    menu: function () {
      this.leftDrawerOpen = !this.leftDrawerOpen
    },
    triggerSearch: function (event) {
      if (event.key === 'Enter') {
        this.searchModalOpened = true
      }
    },
    showHome: function () {
      this.$router.push('/')
      this.displaySearchBar = true
    },
    showApplications: function () {
      this.$router.push('/applications/installed')
      this.displaySearchBar = false
    },
    showCatalog: function () {
      this.$router.push('/applications')
      this.displaySearchBar = false
    },
    showUsers: function () {
      this.$router.push('/users')
      this.displaySearchBar = false
    },
    showCategories: function () {
      this.$router.push('/categories')
      this.displaySearchBar = false
    },
    showPlaylists: function () {
      this.$router.push('/playlists')
      this.displaySearchBar = false
    },
    showThesaurus: function () {
      this.$router.push('/categories/thesaurus')
      this.displaySearchBar = false
    },
    login: function () {
      this.authenticateOidc()
    },
    logoff: async function () {
      this.signOutOidc()
    },
    handleResize: function () {
      this.miniState = window.innerWidth < 1024
    },
    setLanguage: function (locale) {
      import(`src/statics/lang/${locale}`).then(({ default: messages }) => {
        this.$q.i18n.set(messages)
      })
      import(`src/translations/${locale}`).then(({ default: messages }) => {
        this.$i18n.locale = locale
        this.$i18n.setLocaleMessage(locale, messages)
      })
    }
  },
  components: {
    SearchModal
  },
  dependencies: [
    'config'
  ],
  mounted: function () {
    this.getAdminLogo()
    window.addEventListener('resize', this.handleResize)
  }
}
</script>

<style>
.content {
 position: relative;
 width: 100%;
}

.content .image {
 display: block;
 width: 100%;
 height: auto;
}

.button{
    position: absolute;
    top: 45%;
    left: 40%;
    display: none;
    color: rgb(255, 255, 255);
}

.content:hover .image{
filter: brightness(30%);
transition: 1s all ease;
}

.content:hover .button{
display: block;
transition: 1s all ease;
}

</style>
